Index: /LMDZ5/trunk/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/conf_phys_m.F90	(revision 1937)
+++ /LMDZ5/trunk/libf/phylmd/conf_phys_m.F90	(revision 1938)
@@ -1683,5 +1698,5 @@
     RCFC11_per = RCFC11_per_omp
     RCFC12_per = RCFC12_per_omp
-    
+
     cycle_diurne = cycle_diurne_omp
     soil_model = soil_model_omp
@@ -1748,7 +1763,7 @@
     ok_veget=.true.
     type_veget=type_veget_omp
-    if (type_veget=='n' .or. type_veget=='bucket' .or. type_veget=='betaclim' ) &
-         & then
-         ok_veget=.false.
+    if (type_veget=='n' .or. type_veget=='bucket' .or. type_veget=='betaclim') &
+         then
+       ok_veget=.false.
     endif
     ! Martin
@@ -1791,5 +1806,5 @@
     tau_thermals = tau_thermals_omp
     alp_bl_k = alp_bl_k_omp
-!!! nrlmd le 10/04/2012
+    ! nrlmd le 10/04/2012
     iflag_trig_bl = iflag_trig_bl_omp
     s_trig = s_trig_omp
@@ -1797,5 +1812,5 @@
     tau_trig_deep = tau_trig_deep_omp
     iflag_clos_bl = iflag_clos_bl_omp
-!!! fin nrlmd le 10/04/2012
+    ! fin nrlmd le 10/04/2012
     iflag_coupl = iflag_coupl_omp
     iflag_clos = iflag_clos_omp
@@ -1835,4 +1850,7 @@
     ok_strato = ok_strato_omp
     ok_hines = ok_hines_omp
+    ok_gwd_rando = ok_gwd_rando_omp
+    RUWMAX = RUWMAX_omp
+    sat = sat_omp
     ok_LES = ok_LES_omp
     callstats = callstats_omp
@@ -1841,5 +1859,5 @@
     carbon_cycle_cpl = carbon_cycle_cpl_omp
 
-! Test of coherence between type_ocean and version_ocean
+    ! Test of coherence between type_ocean and version_ocean
     IF (type_ocean=='couple' .AND. (version_ocean/='opa8' .AND. version_ocean/='nemo') ) THEN
        WRITE(lunout,*)' ERROR version_ocean=',version_ocean,' not valid in coupled configuration'
@@ -1854,6 +1872,6 @@
     END IF
 
-! Test sur new_aod. Ce flag permet de retrouver les resultats de l'AR4
-! il n'est utilisable que lors du couplage avec le SO4 seul 
+    ! Test sur new_aod. Ce flag permet de retrouver les resultats de l'AR4
+    ! il n'est utilisable que lors du couplage avec le SO4 seul 
     IF (ok_ade .OR. ok_aie) THEN 
        IF ( flag_aerosol .EQ. 0 ) THEN
@@ -1865,164 +1883,167 @@
     END IF
 
-! ok_cdnc must be set to y if ok_aie is activated
+    ! ok_cdnc must be set to y if ok_aie is activated
     IF (ok_aie .AND. .NOT. ok_cdnc) THEN
        CALL abort_gcm('conf_phys', 'ok_cdnc must be set to y if ok_aie is activated',1)
-    ENDIF 
-
-!$OMP MASTER
-
-  write(lunout,*)' ##############################################'
-  write(lunout,*)' Configuration des parametres de la physique: '
-  write(lunout,*)' Type ocean = ', type_ocean
-  write(lunout,*)' Version ocean = ', version_ocean
-  write(lunout,*)' Config veget = ', ok_veget,type_veget
-  write(lunout,*)' Snow model SISVAT : ok_snow = ', ok_snow
-  write(lunout,*)' Sortie journaliere = ', ok_journe
-  write(lunout,*)' Sortie haute frequence = ', ok_hf
-  write(lunout,*)' Sortie mensuelle = ', ok_mensuel
-  write(lunout,*)' Sortie instantanee = ', ok_instan
-  write(lunout,*)' Frequence appel simulateur ISCCP, freq_ISCCP =', freq_ISCCP
-  write(lunout,*)' Frequence appel simulateur ISCCP, ecrit_ISCCP =', ecrit_ISCCP
-  write(lunout,*)' Frequence appel simulateur COSP, freq_COSP =', freq_COSP
-  write(lunout,*)' Sortie bilan d''energie, ip_ebil_phy =', ip_ebil_phy
-  write(lunout,*)' Excentricite = ',R_ecc
-  write(lunout,*)' Equinoxe = ',R_peri
-  write(lunout,*)' Inclinaison =',R_incl
-  write(lunout,*)' Constante solaire =',solaire
-  write(lunout,*)' co2_ppm =',co2_ppm
-  write(lunout,*)' RCO2_act = ',RCO2_act
-  write(lunout,*)' CH4_ppb =',CH4_ppb,' RCH4_act = ',RCH4_act
-  write(lunout,*)' N2O_ppb =',N2O_ppb,' RN2O_act=  ',RN2O_act
-  write(lunout,*)' CFC11_ppt=',CFC11_ppt,' RCFC11_act=  ',RCFC11_act
-  write(lunout,*)' CFC12_ppt=',CFC12_ppt,' RCFC12_act=  ',RCFC12_act
-  write(lunout,*)' ok_4xCO2atm=',ok_4xCO2atm
-  write(lunout,*)' RCO2_per = ',RCO2_per,' RCH4_per = ', RCH4_per
-  write(lunout,*)' RN2O_per = ',RN2O_per,' RCFC11_per = ', RCFC11_per
-  write(lunout,*)' RCFC12_per = ',RCFC12_per
-  write(lunout,*)' cvl_corr=', cvl_corr
-  write(lunout,*)'ok_lic_melt=', ok_lic_melt
-  write(lunout,*)'cycle_diurne=',cycle_diurne
-  write(lunout,*)'soil_model=',soil_model
-  write(lunout,*)'new_oliq=',new_oliq
-  write(lunout,*)'ok_orodr=',ok_orodr
-  write(lunout,*)'ok_orolf=',ok_orolf
-  write(lunout,*)'ok_limitvrai=',ok_limitvrai
-  write(lunout,*)'nbapp_rad=',nbapp_rad
-  write(lunout,*)'iflag_con=',iflag_con
-  write(lunout,*)'iflag_ener_conserv=',iflag_ener_conserv
-  write(lunout,*)'iflag_fisrtilp_qsat=',iflag_fisrtilp_qsat
-  write(lunout,*)' epmax = ', epmax
-  write(lunout,*)' ok_adj_ema = ', ok_adj_ema
-  write(lunout,*)' iflag_clw = ', iflag_clw
-  write(lunout,*)' cld_lc_lsc = ', cld_lc_lsc
-  write(lunout,*)' cld_lc_con = ', cld_lc_con
-  write(lunout,*)' cld_tau_lsc = ', cld_tau_lsc
-  write(lunout,*)' cld_tau_con = ', cld_tau_con
-  write(lunout,*)' ffallv_lsc = ', ffallv_lsc
-  write(lunout,*)' ffallv_con = ', ffallv_con
-  write(lunout,*)' coef_eva = ', coef_eva
-  write(lunout,*)' reevap_ice = ', reevap_ice
-  write(lunout,*)' iflag_pdf = ', iflag_pdf
-  write(lunout,*)' iflag_cldcon = ', iflag_cldcon
-  write(lunout,*)' iflag_radia = ', iflag_radia
-  write(lunout,*)' iflag_rrtm = ', iflag_rrtm
-  write(lunout,*)' iflag_ratqs = ', iflag_ratqs
-  write(lunout,*)' seuil_inversion = ', seuil_inversion
-  write(lunout,*)' fact_cldcon = ', fact_cldcon
-  write(lunout,*)' facttemps = ', facttemps
-  write(lunout,*)' ok_newmicro = ',ok_newmicro 
-  write(lunout,*)' ratqsbas = ',ratqsbas 
-  write(lunout,*)' ratqshaut = ',ratqshaut 
-  write(lunout,*)' tau_ratqs = ',tau_ratqs 
-  write(lunout,*)' top_height = ',top_height 
-  write(lunout,*)' rad_froid = ',rad_froid
-  write(lunout,*)' rad_chau1 = ',rad_chau1
-  write(lunout,*)' rad_chau2 = ',rad_chau2
-  write(lunout,*)' t_glace_min = ',t_glace_min
-  write(lunout,*)' t_glace_max = ',t_glace_max
-  write(lunout,*)' iflag_ice_thermo = ',iflag_ice_thermo
-  write(lunout,*)' rei_min = ',rei_min
-  write(lunout,*)' rei_max = ',rei_max
-  write(lunout,*)' overlap = ',overlap 
-  write(lunout,*)' cdmmax = ',cdmmax 
-  write(lunout,*)' cdhmax = ',cdhmax 
-  write(lunout,*)' ksta = ',ksta 
-  write(lunout,*)' ksta_ter = ',ksta_ter 
-  write(lunout,*)' ok_kzmin = ',ok_kzmin 
-  write(lunout,*)' fmagic = ',fmagic
-  write(lunout,*)' pmagic = ',pmagic
-  write(lunout,*)' ok_ade = ',ok_ade
-  write(lunout,*)' ok_aie = ',ok_aie
-  write(lunout,*)' aerosol_couple = ', aerosol_couple
-  write(lunout,*)' flag_aerosol = ', flag_aerosol
-  write(lunout,*)' flag_aerosol_strat = ', flag_aerosol_strat
-  write(lunout,*)' new_aod = ', new_aod
-  write(lunout,*)' aer_type = ',aer_type
-  write(lunout,*)' bl95_b0 = ',bl95_b0
-  write(lunout,*)' bl95_b1 = ',bl95_b1
-  write(lunout,*)' lev_histhf = ',lev_histhf 
-  write(lunout,*)' lev_histday = ',lev_histday 
-  write(lunout,*)' lev_histmth = ',lev_histmth 
-  write(lunout,*)' lev_histins = ',lev_histins
-  write(lunout,*)' lev_histLES = ',lev_histLES
-  write(lunout,*)' lev_histdayNMC = ',lev_histdayNMC
-  write(lunout,*)' levout_histNMC = ',levout_histNMC
-  write(lunout,*)' ok_histNMC = ',ok_histNMC
-  write(lunout,*)' freq_outNMC = ',freq_outNMC
-  write(lunout,*)' freq_calNMC = ',freq_calNMC
-  write(lunout,*)' iflag_pbl = ', iflag_pbl
-  write(lunout,*)' iflag_thermals = ', iflag_thermals
-  write(lunout,*)' iflag_thermals_ed = ', iflag_thermals_ed
-  write(lunout,*)' iflag_thermals_optflux = ', iflag_thermals_optflux
-  write(lunout,*)' iflag_clos = ', iflag_clos
-  write(lunout,*)' type_run = ',type_run 
-  write(lunout,*)' ok_cosp = ',ok_cosp
-  write(lunout,*)' ok_mensuelCOSP = ',ok_mensuelCOSP
-  write(lunout,*)' ok_journeCOSP = ',ok_journeCOSP
-  write(lunout,*)' ok_hfCOSP =',ok_hfCOSP
-  write(lunout,*)' solarlong0 = ', solarlong0
-  write(lunout,*)' qsol0 = ', qsol0
-  write(lunout,*)' evap0 = ', evap0
-  write(lunout,*)' albsno0 = ', albsno0
-  write(lunout,*)' inertie_sol = ', inertie_sol
-  write(lunout,*)' inertie_ice = ', inertie_ice
-  write(lunout,*)' inertie_sno = ', inertie_sno
-  write(lunout,*)' f_cdrag_ter = ',f_cdrag_ter
-  write(lunout,*)' f_cdrag_oce = ',f_cdrag_oce
-  write(lunout,*)' f_rugoro = ',f_rugoro
-  write(lunout,*)' supcrit1 = ', supcrit1
-  write(lunout,*)' supcrit2 = ', supcrit2
-  write(lunout,*)' iflag_mix = ', iflag_mix
-  write(lunout,*)' scut = ', scut
-  write(lunout,*)' qqa1 = ', qqa1
-  write(lunout,*)' qqa2 = ', qqa2
-  write(lunout,*)' gammas = ', gammas
-  write(lunout,*)' Fmax = ', Fmax
-  write(lunout,*)' alphas = ', alphas
-  write(lunout,*)' iflag_wake = ', iflag_wake
-  write(lunout,*)' alp_offset = ', alp_offset
-!!! nrlmd le 10/04/2012
-  write(lunout,*)' iflag_trig_bl = ', iflag_trig_bl
-  write(lunout,*)' s_trig = ', s_trig
-  write(lunout,*)' tau_trig_shallow = ', tau_trig_shallow
-  write(lunout,*)' tau_trig_deep = ', tau_trig_deep
-  write(lunout,*)' iflag_clos_bl = ', iflag_clos_bl
-!!! fin nrlmd le 10/04/2012
-
-  write(lunout,*)' lonmin lonmax latmin latmax bilKP_ins =',&
-   lonmin_ins, lonmax_ins, latmin_ins, latmax_ins
-  write(lunout,*)' ecrit_ hf, ins, day, mth, reg, tra, ISCCP, LES',&
-   ecrit_hf, ecrit_ins, ecrit_day, ecrit_mth, ecrit_reg, ecrit_tra, ecrit_ISCCP, ecrit_LES
-
-  write(lunout,*) 'ok_strato = ', ok_strato
-  write(lunout,*) 'ok_hines = ',  ok_hines
-  write(lunout,*) 'read_climoz = ', read_climoz
-  write(lunout,*) 'carbon_cycle_tr = ', carbon_cycle_tr
-  write(lunout,*) 'carbon_cycle_cpl = ', carbon_cycle_cpl
-  
-!$OMP END MASTER
-
-  return
-  
+    ENDIF
+
+    !$OMP MASTER
+
+    write(lunout,*)' ##############################################'
+    write(lunout,*)' Configuration des parametres de la physique: '
+    write(lunout,*)' Type ocean = ', type_ocean
+    write(lunout,*)' Version ocean = ', version_ocean
+    write(lunout,*)' Config veget = ', ok_veget,type_veget
+    write(lunout,*)' Snow model SISVAT : ok_snow = ', ok_snow
+    write(lunout,*)' Sortie journaliere = ', ok_journe
+    write(lunout,*)' Sortie haute frequence = ', ok_hf
+    write(lunout,*)' Sortie mensuelle = ', ok_mensuel
+    write(lunout,*)' Sortie instantanee = ', ok_instan
+    write(lunout,*)' Frequence appel simulateur ISCCP, freq_ISCCP =', freq_ISCCP
+    write(lunout,*)' Frequence appel simulateur ISCCP, ecrit_ISCCP =', ecrit_ISCCP
+    write(lunout,*)' Frequence appel simulateur COSP, freq_COSP =', freq_COSP
+    write(lunout,*)' Sortie bilan d''energie, ip_ebil_phy =', ip_ebil_phy
+    write(lunout,*)' Excentricite = ',R_ecc
+    write(lunout,*)' Equinoxe = ',R_peri
+    write(lunout,*)' Inclinaison =',R_incl
+    write(lunout,*)' Constante solaire =',solaire
+    write(lunout,*)' co2_ppm =',co2_ppm
+    write(lunout,*)' RCO2_act = ',RCO2_act
+    write(lunout,*)' CH4_ppb =',CH4_ppb,' RCH4_act = ',RCH4_act
+    write(lunout,*)' N2O_ppb =',N2O_ppb,' RN2O_act=  ',RN2O_act
+    write(lunout,*)' CFC11_ppt=',CFC11_ppt,' RCFC11_act=  ',RCFC11_act
+    write(lunout,*)' CFC12_ppt=',CFC12_ppt,' RCFC12_act=  ',RCFC12_act
+    write(lunout,*)' ok_4xCO2atm=',ok_4xCO2atm
+    write(lunout,*)' RCO2_per = ',RCO2_per,' RCH4_per = ', RCH4_per
+    write(lunout,*)' RN2O_per = ',RN2O_per,' RCFC11_per = ', RCFC11_per
+    write(lunout,*)' RCFC12_per = ',RCFC12_per
+    write(lunout,*)' cvl_corr=', cvl_corr
+    write(lunout,*)'ok_lic_melt=', ok_lic_melt
+    write(lunout,*)'cycle_diurne=',cycle_diurne
+    write(lunout,*)'soil_model=',soil_model
+    write(lunout,*)'new_oliq=',new_oliq
+    write(lunout,*)'ok_orodr=',ok_orodr
+    write(lunout,*)'ok_orolf=',ok_orolf
+    write(lunout,*)'ok_limitvrai=',ok_limitvrai
+    write(lunout,*)'nbapp_rad=',nbapp_rad
+    write(lunout,*)'iflag_con=',iflag_con
+    write(lunout,*)'iflag_ener_conserv=',iflag_ener_conserv
+    write(lunout,*)'iflag_fisrtilp_qsat=',iflag_fisrtilp_qsat
+    write(lunout,*)' epmax = ', epmax
+    write(lunout,*)' ok_adj_ema = ', ok_adj_ema
+    write(lunout,*)' iflag_clw = ', iflag_clw
+    write(lunout,*)' cld_lc_lsc = ', cld_lc_lsc
+    write(lunout,*)' cld_lc_con = ', cld_lc_con
+    write(lunout,*)' cld_tau_lsc = ', cld_tau_lsc
+    write(lunout,*)' cld_tau_con = ', cld_tau_con
+    write(lunout,*)' ffallv_lsc = ', ffallv_lsc
+    write(lunout,*)' ffallv_con = ', ffallv_con
+    write(lunout,*)' coef_eva = ', coef_eva
+    write(lunout,*)' reevap_ice = ', reevap_ice
+    write(lunout,*)' iflag_pdf = ', iflag_pdf
+    write(lunout,*)' iflag_cldcon = ', iflag_cldcon
+    write(lunout,*)' iflag_radia = ', iflag_radia
+    write(lunout,*)' iflag_rrtm = ', iflag_rrtm
+    write(lunout,*)' iflag_ratqs = ', iflag_ratqs
+    write(lunout,*)' seuil_inversion = ', seuil_inversion
+    write(lunout,*)' fact_cldcon = ', fact_cldcon
+    write(lunout,*)' facttemps = ', facttemps
+    write(lunout,*)' ok_newmicro = ',ok_newmicro 
+    write(lunout,*)' ratqsbas = ',ratqsbas 
+    write(lunout,*)' ratqshaut = ',ratqshaut 
+    write(lunout,*)' tau_ratqs = ',tau_ratqs 
+    write(lunout,*)' top_height = ',top_height 
+    write(lunout,*)' rad_froid = ',rad_froid
+    write(lunout,*)' rad_chau1 = ',rad_chau1
+    write(lunout,*)' rad_chau2 = ',rad_chau2
+    write(lunout,*)' t_glace_min = ',t_glace_min
+    write(lunout,*)' t_glace_max = ',t_glace_max
+    write(lunout,*)' iflag_ice_thermo = ',iflag_ice_thermo
+    write(lunout,*)' rei_min = ',rei_min
+    write(lunout,*)' rei_max = ',rei_max
+    write(lunout,*)' overlap = ',overlap 
+    write(lunout,*)' cdmmax = ',cdmmax 
+    write(lunout,*)' cdhmax = ',cdhmax 
+    write(lunout,*)' ksta = ',ksta 
+    write(lunout,*)' ksta_ter = ',ksta_ter 
+    write(lunout,*)' ok_kzmin = ',ok_kzmin 
+    write(lunout,*)' fmagic = ',fmagic
+    write(lunout,*)' pmagic = ',pmagic
+    write(lunout,*)' ok_ade = ',ok_ade
+    write(lunout,*)' ok_aie = ',ok_aie
+    write(lunout,*)' aerosol_couple = ', aerosol_couple
+    write(lunout,*)' flag_aerosol = ', flag_aerosol
+    write(lunout,*)' flag_aerosol_strat = ', flag_aerosol_strat
+    write(lunout,*)' new_aod = ', new_aod
+    write(lunout,*)' aer_type = ',aer_type
+    write(lunout,*)' bl95_b0 = ',bl95_b0
+    write(lunout,*)' bl95_b1 = ',bl95_b1
+    write(lunout,*)' lev_histhf = ',lev_histhf 
+    write(lunout,*)' lev_histday = ',lev_histday 
+    write(lunout,*)' lev_histmth = ',lev_histmth 
+    write(lunout,*)' lev_histins = ',lev_histins
+    write(lunout,*)' lev_histLES = ',lev_histLES
+    write(lunout,*)' lev_histdayNMC = ',lev_histdayNMC
+    write(lunout,*)' levout_histNMC = ',levout_histNMC
+    write(lunout,*)' ok_histNMC = ',ok_histNMC
+    write(lunout,*)' freq_outNMC = ',freq_outNMC
+    write(lunout,*)' freq_calNMC = ',freq_calNMC
+    write(lunout,*)' iflag_pbl = ', iflag_pbl
+    write(lunout,*)' iflag_thermals = ', iflag_thermals
+    write(lunout,*)' iflag_thermals_ed = ', iflag_thermals_ed
+    write(lunout,*)' iflag_thermals_optflux = ', iflag_thermals_optflux
+    write(lunout,*)' iflag_clos = ', iflag_clos
+    write(lunout,*)' type_run = ',type_run 
+    write(lunout,*)' ok_cosp = ',ok_cosp
+    write(lunout,*)' ok_mensuelCOSP = ',ok_mensuelCOSP
+    write(lunout,*)' ok_journeCOSP = ',ok_journeCOSP
+    write(lunout,*)' ok_hfCOSP =',ok_hfCOSP
+    write(lunout,*)' solarlong0 = ', solarlong0
+    write(lunout,*)' qsol0 = ', qsol0
+    write(lunout,*)' evap0 = ', evap0
+    write(lunout,*)' albsno0 = ', albsno0
+    write(lunout,*)' inertie_sol = ', inertie_sol
+    write(lunout,*)' inertie_ice = ', inertie_ice
+    write(lunout,*)' inertie_sno = ', inertie_sno
+    write(lunout,*)' f_cdrag_ter = ',f_cdrag_ter
+    write(lunout,*)' f_cdrag_oce = ',f_cdrag_oce
+    write(lunout,*)' f_rugoro = ',f_rugoro
+    write(lunout,*)' supcrit1 = ', supcrit1
+    write(lunout,*)' supcrit2 = ', supcrit2
+    write(lunout,*)' iflag_mix = ', iflag_mix
+    write(lunout,*)' scut = ', scut
+    write(lunout,*)' qqa1 = ', qqa1
+    write(lunout,*)' qqa2 = ', qqa2
+    write(lunout,*)' gammas = ', gammas
+    write(lunout,*)' Fmax = ', Fmax
+    write(lunout,*)' alphas = ', alphas
+    write(lunout,*)' iflag_wake = ', iflag_wake
+    write(lunout,*)' alp_offset = ', alp_offset
+    ! nrlmd le 10/04/2012
+    write(lunout,*)' iflag_trig_bl = ', iflag_trig_bl
+    write(lunout,*)' s_trig = ', s_trig
+    write(lunout,*)' tau_trig_shallow = ', tau_trig_shallow
+    write(lunout,*)' tau_trig_deep = ', tau_trig_deep
+    write(lunout,*)' iflag_clos_bl = ', iflag_clos_bl
+    ! fin nrlmd le 10/04/2012
+
+    write(lunout,*)' lonmin lonmax latmin latmax bilKP_ins =',&
+         lonmin_ins, lonmax_ins, latmin_ins, latmax_ins
+    write(lunout,*)' ecrit_ hf, ins, day, mth, reg, tra, ISCCP, LES',&
+         ecrit_hf, ecrit_ins, ecrit_day, ecrit_mth, ecrit_reg, ecrit_tra, ecrit_ISCCP, ecrit_LES
+
+    write(lunout,*) 'ok_strato = ', ok_strato
+    write(lunout,*) 'ok_hines = ',  ok_hines
+    write(lunout,*) 'ok_gwd_rando = ',  ok_gwd_rando
+    write(lunout,*) 'RUWMAX = ', RUWMAX
+    write(lunout,*) 'sat = ', sat
+    write(lunout,*) 'read_climoz = ', read_climoz
+    write(lunout,*) 'carbon_cycle_tr = ', carbon_cycle_tr
+    write(lunout,*) 'carbon_cycle_cpl = ', carbon_cycle_cpl
+
+    !$OMP END MASTER
+
+    return
+
   end subroutine conf_phys
 
@@ -2032,37 +2053,37 @@
 !
 
-   subroutine conf_interface(tau_calv)
-
-   use IOIPSL
-   implicit none
-   include "iniprint.h"
-! Configuration de l'interace atm/surf
-!
-! tau_calv:    temps de relaxation pour la fonte des glaciers
+subroutine conf_interface(tau_calv)
+
+  use IOIPSL
+  implicit none
+  include "iniprint.h"
+  ! Configuration de l'interace atm/surf
+  !
+  ! tau_calv:    temps de relaxation pour la fonte des glaciers
 
   REAL          :: tau_calv
   REAL,SAVE     :: tau_calv_omp
 
-!
-!Config Key  = tau_calv
-!Config Desc = temps de relaxation pour fonte des glaciers en jours
-!Config Def  = 1 an 
-!Config Help = 
-!
+  !
+  !Config Key  = tau_calv
+  !Config Desc = temps de relaxation pour fonte des glaciers en jours
+  !Config Def  = 1 an 
+  !Config Help = 
+  !
   tau_calv_omp = 360.*10.
-!$OMP MASTER
+  !$OMP MASTER
   call getin('tau_calv',tau_calv_omp)
-!$OMP END MASTER
-!$OMP BARRIER
+  !$OMP END MASTER
+  !$OMP BARRIER
 
   tau_calv=tau_calv_omp
-  
-!$OMP MASTER
+
+  !$OMP MASTER
   write(lunout,*)' ##############################################'
   WRITE(lunout,*)' Configuration de l''interface atm/surfaces  : '
   WRITE(lunout,*)' tau_calv = ',tau_calv
-!$OMP END MASTER
+  !$OMP END MASTER
 
   return
 
-  end subroutine conf_interface
+end subroutine conf_interface
Index: /LMDZ5/trunk/libf/phylmd/flott_gwd_rando_m.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/flott_gwd_rando_m.F90	(revision 1938)
+++ /LMDZ5/trunk/libf/phylmd/flott_gwd_rando_m.F90	(revision 1938)
@@ -0,0 +1,374 @@
+module FLOTT_GWD_rando_m
+
+  implicit none
+
+contains
+
+  SUBROUTINE FLOTT_GWD_rando(DTIME, pp, tt, uu, vv, prec, zustr, zvstr, d_u, &
+       d_v)
+
+    ! Parametrization of the momentum flux deposition due to a discrete
+    ! number of gravity waves. 
+    ! Author: F. Lott
+    ! July, 12th, 2012
+    ! Gaussian distribution of the source, source is precipitation
+    ! Reference: Lott (JGR, vol 118, page 8897, 2013)
+
+    use dimphy, only: klon, klev
+    use assert_m, only: assert
+
+    include "YOMCST.h"
+    include "clesphys.h"
+    include "YOEGWD.h"
+
+    ! 0. DECLARATIONS:
+
+    ! 0.1 INPUTS
+    REAL, intent(in)::DTIME ! Time step of the Physics
+    REAL, intent(in):: pp(:, :) ! (KLON, KLEV) Pressure at full levels
+    REAL, intent(in):: prec(:) ! (klon) Precipitation (kg/m^2/s) 
+    REAL, intent(in):: TT(:, :) ! (KLON, KLEV) Temp at full levels 
+    REAL, intent(in):: UU(:, :) ! (KLON, KLEV) Zonal wind at full levels
+    REAL, intent(in):: VV(:, :) ! (KLON, KLEV) Merid wind at full levels
+
+    ! 0.2 OUTPUTS
+    REAL, intent(out):: zustr(:), zvstr(:) ! (KLON) Surface Stresses
+
+    REAL, intent(inout):: d_u(:, :), d_v(:, :) 
+    ! (KLON, KLEV) tendencies on winds
+
+    ! O.3 INTERNAL ARRAYS
+    REAL BVLOW(klon)
+
+    INTEGER II, LL
+
+    ! 0.3.0 TIME SCALE OF THE LIFE CYCLE OF THE WAVES PARAMETERIZED
+
+    REAL DELTAT
+
+    ! 0.3.1 GRAVITY-WAVES SPECIFICATIONS
+
+    INTEGER, PARAMETER:: NK = 2, NP = 2, NO = 2, NW = NK * NP * NO
+    INTEGER JK, JP, JO, JW
+    REAL KMIN, KMAX ! Min and Max horizontal wavenumbers
+    REAL CMIN, CMAX ! Min and Max absolute ph. vel.
+    REAL CPHA ! absolute PHASE VELOCITY frequency
+    REAL ZK(NW, KLON) ! Horizontal wavenumber amplitude
+    REAL ZP(NW, KLON) ! Horizontal wavenumber angle 
+    REAL ZO(NW, KLON) ! Absolute frequency !
+
+    ! Waves Intr. freq. at the 1/2 lev surrounding the full level
+    REAL ZOM(NW, KLON), ZOP(NW, KLON)
+
+    ! Wave EP-fluxes at the 2 semi levels surrounding the full level
+    REAL WWM(NW, KLON), WWP(NW, KLON)
+
+    REAL RUW0(NW, KLON) ! Fluxes at launching level
+
+    REAL RUWP(NW, KLON), RVWP(NW, KLON)
+    ! Fluxes X and Y for each waves at 1/2 Levels
+
+    INTEGER LAUNCH, LTROP ! Launching altitude and tropo altitude
+
+    REAL XLAUNCH ! Controle the launching altitude
+    REAL XTROP ! SORT of Tropopause altitude 
+    REAL RUW(KLON, KLEV + 1) ! Flux x at semi levels
+    REAL RVW(KLON, KLEV + 1) ! Flux y at semi levels
+
+    REAL PRMAX ! Maximum value of PREC, and for which our linear formula
+    ! for GWs parameterisation apply
+
+    ! 0.3.2 PARAMETERS OF WAVES DISSIPATIONS
+
+    REAL RDISS, ZOISEC ! COEFF DE DISSIPATION, SECURITY FOR INTRINSIC FREQ
+
+    ! 0.3.3 BACKGROUND FLOW AT 1/2 LEVELS AND VERTICAL COORDINATE
+
+    REAL H0 ! Characteristic Height of the atmosphere
+    REAL DZ ! Characteristic depth of the source!
+    REAL PR, TR ! Reference Pressure and Temperature
+
+    REAL ZH(KLON, KLEV + 1) ! Log-pressure altitude
+
+    REAL UH(KLON, KLEV + 1), VH(KLON, KLEV + 1) ! Winds at 1/2 levels
+    REAL PH(KLON, KLEV + 1) ! Pressure at 1/2 levels
+    REAL PSEC ! Security to avoid division by 0 pressure
+    REAL PHM1(KLON, KLEV + 1) ! 1/Press at 1/2 levels
+    REAL BV(KLON, KLEV + 1) ! Brunt Vaisala freq. (BVF) at 1/2 levels
+    REAL BVSEC ! Security to avoid negative BVF
+
+    !-----------------------------------------------------------------
+
+    ! 1. INITIALISATIONS
+
+    ! 1.1 Basic parameter
+
+    ! Are provided from elsewhere (latent heat of vaporization, dry
+    ! gaz constant for air, gravity constant, heat capacity of dry air
+    ! at constant pressure, earth rotation rate, pi).
+
+    ! 1.2 Tuning parameters of V14
+
+    RDISS = 1. ! Diffusion parameter 
+
+    PRMAX = 20. / 24. /3600.
+    ! maximum of rain for which our theory applies (in kg/m^2/s)
+
+    DZ = 1000. ! Characteristic depth of the source
+    XLAUNCH=0.5 ! Parameter that control launching altitude
+    XTROP=0.2 ! Parameter that control tropopause altitude
+    DELTAT=24.*3600. ! Time scale of the waves (first introduced in 9b)
+
+    KMIN = 2.E-5
+    ! minimum horizontal wavenumber (inverse of the subgrid scale resolution)
+
+    KMAX = 1.E-3 ! Max horizontal wavenumber
+    CMIN = 1. ! Min phase velocity
+    CMAX = 50. ! Max phase speed velocity
+
+    TR = 240. ! Reference Temperature
+    PR = 101300. ! Reference pressure
+    H0 = RD * TR / RG ! Characteristic vertical scale height
+
+    BVSEC = 5.E-3 ! Security to avoid negative BVF 
+    PSEC = 1.E-6 ! Security to avoid division by 0 pressure
+    ZOISEC = 1.E-6 ! Security FOR 0 INTRINSIC FREQ
+
+    call assert(klon == (/size(pp, 1), size(tt, 1), size(uu, 1), &
+         size(vv, 1), size(prec), size(zustr), size(zvstr), size(d_u, 1), &
+         size(d_v, 1)/), "FLOTT_GWD_RANDO klon")
+    call assert(klev == (/size(pp, 2), size(tt, 2), size(uu, 2), &
+         size(vv, 2), size(d_u, 2), size(d_v, 2)/), "FLOTT_GWD_RANDO klev")
+
+    IF(DELTAT < DTIME)THEN
+       PRINT *, 'flott_gwd_rando: deltat < dtime!'
+       STOP 1
+    ENDIF
+
+    IF (KLEV < NW) THEN
+       PRINT *, 'flott_gwd_rando: you will have problem with random numbers'
+       STOP 1
+    ENDIF
+
+    ! 2. EVALUATION OF THE BACKGROUND FLOW AT SEMI-LEVELS
+
+    ! Pressure and Inv of pressure
+    DO LL = 2, KLEV
+       PH(:, LL) = EXP((LOG(PP(:, LL)) + LOG(PP(:, LL - 1))) / 2.)
+       PHM1(:, LL) = 1. / PH(:, LL) 
+    end DO
+
+    PH(:, KLEV + 1) = 0. 
+    PHM1(:, KLEV + 1) = 1. / PSEC
+    PH(:, 1) = 2. * PP(:, 1) - PH(:, 2)
+
+    ! Launching altitude
+
+    LAUNCH=0
+    LTROP =0
+    DO LL = 1, KLEV
+       IF (PH(KLON / 2, LL) / PH(KLON / 2, 1) > XLAUNCH) LAUNCH = LL
+    ENDDO
+    DO LL = 1, KLEV
+       IF (PH(KLON / 2, LL) / PH(KLON / 2, 1) > XTROP) LTROP = LL
+    ENDDO
+
+    ! Log pressure vert. coordinate
+    DO LL = 1, KLEV + 1 
+       ZH(:, LL) = H0 * LOG(PR / (PH(:, LL) + PSEC))
+    end DO
+
+    ! BV frequency
+    DO LL = 2, KLEV
+       ! BVSEC: BV Frequency (UH USED IS AS A TEMPORARY ARRAY DOWN TO WINDS)
+       UH(:, LL) = 0.5 * (TT(:, LL) + TT(:, LL - 1)) &
+            * RD**2 / RCPD / H0**2 + (TT(:, LL) &
+            - TT(:, LL - 1)) / (ZH(:, LL) - ZH(:, LL - 1)) * RD / H0
+    end DO
+    BVLOW = 0.5 * (TT(:, LTROP )+ TT(:, LAUNCH)) &
+         * RD**2 / RCPD / H0**2 + (TT(:, LTROP ) &
+         - TT(:, LAUNCH))/(ZH(:, LTROP )- ZH(:, LAUNCH)) * RD / H0
+
+    UH(:, 1) = UH(:, 2)
+    UH(:, KLEV + 1) = UH(:, KLEV)
+    BV(:, 1) = UH(:, 2)
+    BV(:, KLEV + 1) = UH(:, KLEV)
+    ! SMOOTHING THE BV HELPS
+    DO LL = 2, KLEV
+       BV(:, LL)=(UH(:, LL+1)+2.*UH(:, LL)+UH(:, LL-1))/4.
+    end DO
+
+    BV=MAX(SQRT(MAX(BV, 0.)), BVSEC)
+    BVLOW=MAX(SQRT(MAX(BVLOW, 0.)), BVSEC)
+
+    ! WINDS
+    DO LL = 2, KLEV
+       UH(:, LL) = 0.5 * (UU(:, LL) + UU(:, LL - 1)) ! Zonal wind
+       VH(:, LL) = 0.5 * (VV(:, LL) + VV(:, LL - 1)) ! Meridional wind
+    end DO
+    UH(:, 1) = 0.
+    VH(:, 1) = 0.
+    UH(:, KLEV + 1) = UU(:, KLEV)
+    VH(:, KLEV + 1) = VV(:, KLEV)
+
+    ! 3 WAVES CHARACTERISTICS CHOSEN RANDOMLY AT THE LAUNCH ALTITUDE
+
+    ! The mod functions of weird arguments are used to produce the
+    ! waves characteristics in an almost stochastic way
+
+    JW = 0
+    DO JP = 1, NP
+       DO JK = 1, NK
+          DO JO = 1, NO
+             JW = JW + 1
+             ! Angle
+             DO II = 1, KLON
+                ! Angle (0 or PI so far)
+                ZP(JW, II) = (SIGN(1., 0.5 - MOD(TT(II, JW) * 10., 1.)) + 1.) &
+                     * RPI / 2.
+                ! Horizontal wavenumber amplitude
+                ZK(JW, II) = KMIN + (KMAX - KMIN) * MOD(TT(II, JW) * 100., 1.)
+                ! Horizontal phase speed
+                CPHA = CMIN + (CMAX - CMIN) * MOD(TT(II, JW)**2, 1.)
+                ! Absolute frequency is imposed
+                ZO(JW, II) = CPHA * ZK(JW, II) 
+                ! Intrinsic frequency is imposed
+                ZO(JW, II) = ZO(JW, II) &
+                     + ZK(JW, II) * COS(ZP(JW, II)) * UH(II, LAUNCH) &
+                     + ZK(JW, II) * SIN(ZP(JW, II)) * VH(II, LAUNCH)
+                ! Momentum flux at launch lev 
+                RUW0(JW, II) = RUWMAX
+             ENDDO
+          end DO
+       end DO
+    end DO
+
+    ! 4. COMPUTE THE FLUXES
+
+    ! 4.1 Vertical velocity at launching altitude to ensure 
+    ! the correct value to the imposed fluxes.
+
+    DO JW = 1, NW
+
+       ! Evaluate intrinsic frequency at launching altitude:
+       ZOP(JW, :) = ZO(JW, :) &
+            - ZK(JW, :) * COS(ZP(JW, :)) * UH(:, LAUNCH) &
+            - ZK(JW, :) * SIN(ZP(JW, :)) * VH(:, LAUNCH) 
+
+       ! VERSION WITH CONVECTIVE SOURCE
+
+       ! Vertical velocity at launch level, value to ensure the
+       ! imposed factor related to the convective forcing:
+       ! precipitations.
+
+       ! tanh limitation to values above prmax:
+       WWP(JW, :) = RUW0(JW, :) &
+            * (RD / RCPD / H0 * RLVTT * PRMAX * TANH(PREC / PRMAX))**2
+
+       ! Factor related to the characteristics of the waves:
+       WWP(JW, :) = WWP(JW, :) * ZK(JW, :)**3 / KMIN / BVLOW &
+            / MAX(ABS(ZOP(JW, :)), ZOISEC)**3 
+
+       ! Moderation by the depth of the source (dz here):
+       WWP(JW, :) = WWP(JW, :) &
+            * EXP(- BVLOW**2 / MAX(ABS(ZOP(JW, :)), ZOISEC)**2 * ZK(JW, :)**2 &
+            * DZ**2)
+
+       ! Put the stress in the right direction:
+       RUWP(JW, :) = ZOP(JW, :) / MAX(ABS(ZOP(JW, :)), ZOISEC)**2 &
+            * BV(:, LAUNCH) * COS(ZP(JW, :)) * WWP(JW, :)**2
+       RVWP(JW, :) = ZOP(JW, :) / MAX(ABS(ZOP(JW, :)), ZOISEC)**2 &
+            * BV(:, LAUNCH) * SIN(ZP(JW, :)) * WWP(JW, :)**2
+    end DO
+
+    ! 4.2 Uniform values below the launching altitude
+
+    DO LL = 1, LAUNCH
+       RUW(:, LL) = 0
+       RVW(:, LL) = 0
+       DO JW = 1, NW
+          RUW(:, LL) = RUW(:, LL) + RUWP(JW, :)
+          RVW(:, LL) = RVW(:, LL) + RVWP(JW, :)
+       end DO
+    end DO
+
+    ! 4.3 Loop over altitudes, with passage from one level to the next
+    ! done by i) conserving the EP flux, ii) dissipating a little,
+    ! iii) testing critical levels, and vi) testing the breaking.
+
+    DO LL = LAUNCH, KLEV - 1
+       ! Warning: all the physics is here (passage from one level
+       ! to the next)
+       DO JW = 1, NW
+          ZOM(JW, :) = ZOP(JW, :)
+          WWM(JW, :) = WWP(JW, :)
+          ! Intrinsic Frequency
+          ZOP(JW, :) = ZO(JW, :) - ZK(JW, :) * COS(ZP(JW, :)) * UH(:, LL + 1) &
+               - ZK(JW, :) * SIN(ZP(JW, :)) * VH(:, LL + 1) 
+
+          ! No breaking (Eq.6)
+          ! Dissipation (Eq. 8)
+          WWP(JW, :) = WWM(JW, :) * EXP(- 2. * RDISS * PR / (PH(:, LL + 1) &
+               + PH(:, LL)) * ((BV(:, LL + 1) + BV(:, LL)) / 2.)**3 &
+               / MAX(ABS(ZOP(JW, :) + ZOM(JW, :)) / 2., ZOISEC)**4 &
+               * ZK(JW, :)**3 * (ZH(:, LL + 1) - ZH(:, LL)))
+
+          ! Critical levels (forced to zero if intrinsic frequency changes sign)
+          ! Saturation (Eq. 12)
+          WWP(JW, :) = min(WWP(JW, :), MAX(0., &
+               SIGN(1., ZOP(JW, :) * ZOM(JW, :))) * ABS(ZOP(JW, :))**3 &
+               / BV(:, LL + 1) * EXP(- ZH(:, LL + 1) / H0) * SAT**2 * KMIN**2 &
+               / ZK(JW, :)**4)
+       end DO
+
+       ! Evaluate EP-flux from Eq. 7 and give the right orientation to
+       ! the stress
+
+       DO JW = 1, NW
+          RUWP(JW, :) = SIGN(1., ZOP(JW, :))*COS(ZP(JW, :)) * WWP(JW, :)
+          RVWP(JW, :) = SIGN(1., ZOP(JW, :))*SIN(ZP(JW, :)) * WWP(JW, :)
+       end DO
+
+       RUW(:, LL + 1) = 0.
+       RVW(:, LL + 1) = 0.
+
+       DO JW = 1, NW
+          RUW(:, LL + 1) = RUW(:, LL + 1) + RUWP(JW, :) 
+          RVW(:, LL + 1) = RVW(:, LL + 1) + RVWP(JW, :) 
+       end DO
+    end DO
+
+    ! 5 CALCUL DES TENDANCES:
+
+    ! 5.1 Rectification des flux au sommet et dans les basses couches
+
+    RUW(:, KLEV + 1) = 0.
+    RVW(:, KLEV + 1) = 0.
+    RUW(:, 1) = RUW(:, LAUNCH)
+    RVW(:, 1) = RVW(:, LAUNCH)
+    DO LL = 1, LAUNCH
+       RUW(:, LL) = RUW(:, LAUNCH+1)
+       RVW(:, LL) = RVW(:, LAUNCH+1)
+    end DO
+
+    ! AR-1 RECURSIVE FORMULA (13) IN VERSION 4
+    DO LL = 1, KLEV
+       D_U(:, LL) = (1.-DTIME/DELTAT) * D_U(:, LL) + DTIME/DELTAT/REAL(NW) * &
+            RG * (RUW(:, LL + 1) - RUW(:, LL)) &
+            / (PH(:, LL + 1) - PH(:, LL)) * DTIME
+       D_V(:, LL) = (1.-DTIME/DELTAT) * D_V(:, LL) + DTIME/DELTAT/REAL(NW) * &
+            RG * (RVW(:, LL + 1) - RVW(:, LL)) &
+            / (PH(:, LL + 1) - PH(:, LL)) * DTIME
+    ENDDO
+
+    ! Cosmetic: evaluation of the cumulated stress
+    ZUSTR = 0.
+    ZVSTR = 0.
+    DO LL = 1, KLEV
+       ZUSTR = ZUSTR + D_U(:, LL) / RG * (PH(:, LL + 1) - PH(:, LL))/DTIME
+       ZVSTR = ZVSTR + D_V(:, LL) / RG * (PH(:, LL + 1) - PH(:, LL))/DTIME
+    ENDDO
+
+  END SUBROUTINE FLOTT_GWD_RANDO
+
+end module FLOTT_GWD_rando_m
